#! /usr/bin/perl

use strict;
use File::Path;


my $response; #переменная для получения результата системных команд

my $help = "Управление: archive.pl [compression] [compressionlevel] [directory] [file.exp] [new name]
		[directory]		- path to files
		[compression] 		- tar|gzip
		[compressionlevel] 	- 1-9, see gzip manual
		[file.exp]		- file expansion (.log .dis)
		[new name]		- 'n'-create new name(oldname-yyyymmdd-hh-mmss), 'o'-old name(add only .tar or .gz)\n";

my ($compression, $compressionlevel, $DIR, $EXP, $new ) = @ARGV;

if($compression=~m/tar|gzip/ && $compressionlevel=~m/[1-9]/ && $DIR=~m:^/.*: && $EXP=~m/\w+/ && $new=~m/n|o/)
{
  my @time = localtime(time);
  my $year = 1900 + $time[5];
  my $month = 1+ $time[4];
  $month = $month<10?"0".$month:$month;
  my $day = $time[3]<10?"0".$time[3]:$time[3];
  my $hour = $time[2]<10?"0".$time[2]:$time[2];
  my $min = $time[1]<10?"0".$time[1]:$time[1];
  my $sec = $time[0]<10?"0".$time[0]:$time[0];

  opendir (DIR,"$DIR");
  foreach my $cur_file (readdir(DIR))
  {
	if( $cur_file =~ /$EXP$/ )  
	{
	  my $new_filename = $cur_file;
	  $new_filename = $cur_file."-".$year.$month.$day."-".$hour.$min.$sec if($new eq "n");

	  if($compression eq "tar")
	  {
    	$response = `tar -C $DIR -cf $DIR/$new_filename.tar $cur_file`;
	  }
	  else
	  {
    	$response = `gzip -c -$compressionlevel  $DIR/$cur_file > $DIR/$new_filename.gz`;
	  }
	  $response = `rm $DIR/$cur_file`;
	}
  }
  closedir (DIR);
}
elsif($compression=~/^--help$/)
{
	print "$help\n";
}
else
{
	print "archive: неверный аргумент «($compression, $compressionlevel, $DIR, $EXP )»\nПопробуйте `archive.pl --help' для получения более подробного описания.\n";
}


sub filelist
{
    print "gzip\n";
    my $resp = `cd $ARGV[2]`;
    my @response = `ls`;
	my ($year,$month, $day, $hour, $min, $sec);
    my @files;
    foreach(@response)
    {
	  if(/^colit-(\d{4})(\d{2})(\d{2})\.log$/)
	  {
	    chomp;
 	    if($3 ne $day || $2 ne $month || $1 ne $year)
	    {
		push @files, $_;
	    }
	  }
    }
    foreach(@files)
    {
	  $resp = ` gzip -c -$ARGV[1] $_ >> colit-$year$month$day-$hour$min$sec.gz`;
	  $resp = `rm $_`;
    }
}

